--Author:Ampoliros (poorly). I'm an engineer, not a coder.

--calculates extraction area points from radius
--code paraphrased from redblobgames - axial discards the y
function ExtractionArea(r)
	local holder={}
	local z=0
	for x=-r,r do
		for y=Max(-r,-x-r),Min(r,-x+r) do
			 z = -x-y
			holder[#holder+1]=point(x,z)
		end
	end
	return holder
end

--Fixes the lack of texture issue, adds the UI overlay because the default tools don't work...(?)
function OnMsg.ModsLoaded()
	ReapplyAllBuildingPalettes()
	if not table.find(XTemplates.sectionServiceArea,"__context_of_kind","WideAreaExtractor") then
		XTemplates.sectionServiceArea[#XTemplates.sectionServiceArea+1]=XTemplates.sectionWideArea[1]
	end
end


--The WideAreaExtractor class doesn't use the RegolithExtractor as a parent due to the
--overrides that would be needed to remove the grinding disc code and extraction shapes
--(which would get messy). However, ideally they would both do so.
DefineClass.WideAreaExtractor = {
  __parents = {
    "Mine",
	"OutsideBuildingWithShifts",
    "DustGenerator",
    "TerrainDepositExtractor",
  },
  exploitation_resource = "Concrete",
  additional_stockpile_params2 = {
    apply_to_grids = false,
    has_platform = true,
    snap_to_grid = false,
    priority = 2,
    additional_supply_flags = const.rfSpecialDemandPairing
  },
     properties ={ {
      id = "UIWorkRadius",
      name = T({643, "Range"}),
      editor = "number",
      default = 6,
      min = 1,
      max = 12,
      no_edit = true,
      dont_save = true
    },
    {
      id = "work_radius",
      editor = "number",
      default = 6,
      no_edit = true
    }}
  }

--Most of this is pulled from the Regolith Extractor code verbatim and find/replaced.

function WideAreaExtractor.OnCalcProduction_Concrete(producer, amount_to_produce)
  if amount_to_produce > 0 then
    local deposit_multipler = producer.parent:GetCurrentDepositQualityMultiplier()
    amount_to_produce = MulDivRound(amount_to_produce, deposit_multipler, 100)
    if producer.parent:HasMember("performance") then
      amount_to_produce = MulDivRound(amount_to_produce, producer.parent.performance, 100)
    end
    return amount_to_produce
  end
  return 0
end
function WideAreaExtractor.OnProduce_Concrete(producer, amount_to_produce)
  amount_to_produce = producer.parent:ExtractResource(amount_to_produce)
  return amount_to_produce
end
function WideAreaExtractor.GetPredictedProduction_Concrete(producer)
  return producer.parent:GetHourPredictedProduction()
end
function WideAreaExtractor.GetPredictedDailyProduction_Concrete(producer)
  local deposit_multiplier = producer.parent:GetCurrentDepositQualityMultiplier()
  return MulDivRound(SingleResourceProducer.GetPredictedDailyProduction(producer), deposit_multiplier, 100)
end
function WideAreaExtractor:HasNearbyDeposits()
  return TerrainDepositExtractor.HasNearbyDeposits(self)
end
function WideAreaExtractor:GetExtractionShape()
  return ExtractionArea(self.work_radius)
end

function WideAreaExtractor:GetSupplyGridConnectionShapePoints(supply_resource)
  return self:GetShapePoints(supply_resource)
end
function WideAreaExtractor:GetDepositResource()
  return self.exploitation_resource
end
function WideAreaExtractor:GatherNearbyDeposits()
end
function WideAreaExtractor:IsTechLocked()
end
function WideAreaExtractor:CanExploit()
  return self:CheckDeposit()
end
function WideAreaExtractor:OnDepositDepleted(deposit)
  Mine.OnDepositDepleted(self, deposit)
end
function WideAreaExtractor:GetCurrentDepositQualityMultiplier(...)
  return TerrainDepositExtractor.GetCurrentDepositQualityMultiplier(self, ...)
end
function WideAreaExtractor:ExtractResource(...)
  return TerrainDepositExtractor.ExtractResource(self, ...)
end
function WideAreaExtractor:GatherConstructionStatuses(statuses)
  local closest_deposit = self:FindClosestDeposit()
  local percents = self:GetCurrentDepositQualityMultiplier(closest_deposit)
  local amount = self:GetAmount()
  if percents == 0 or amount == 0 then
    statuses[#statuses + 1] = ConstructionStatus.ResourceRequired
  else
    local status = table.copy(ConstructionStatus.DepositInfo)
    status.text = T({
      status.text,
      {
        resource = FormatResource(amount, self.exploitation_resource, empty_table),
        grade = self:Getgrade_name(closest_deposit),
        col = ConstructionStatusColors.info.color_tag
      }
    })
    statuses[#statuses + 1] = status
  end
  ElectricityConsumer.GatherConstructionStatuses(self, statuses)
end
function WideAreaExtractor:GetDepositGrade(...)
  return TerrainDepositExtractor.GetDepositGrade(self, ...)
end

--these are pulled together from the drone hub hex radius functions. adjustments were made due to the fact that 
--this has to recalc extraction shape on adjustment, which may change the extraction state - hence the
--UpdateWorking()/UpdateConsumption() call to recheck.
function WideAreaExtractor:GetSelectionRadiusScale()
    return self.work_radius
end

function WideAreaExtractor:SetUIWorkRadius(value)
  self.UIWorkRadius = value
  self:SetWorkRadius(value)
  local rxs = self:GetAttaches("RangeHexMultiSelectRadius") or empty_table
  for i = 1, #rxs do
    rxs[i]:SetScale(self.work_radius)
  end
  self:UpdateConsumption()
  self:UpdateWorking()
end

function WideAreaExtractor:SetWorkRadius(radius)
  self.work_radius = radius
 end